#include "myString.h"


String::String()
{
	size = 0;
	charArr = new char[size + 1];
	strcpy_s(charArr, size + 1, "");
}


String::String(const char* ch)
{
	size = strlen(ch);
	charArr = new char[size + 1];
	strcpy_s(charArr, size + 1, ch);
}


String::~String()
{
	delete[] charArr;
}


String::String(const String& str)
{
	size = str.size;
	charArr = new char[size + 1];
	strcpy_s(charArr, size + 1, str.charArr);
}


bool String::check(int i) const
{
	return (i >= 0 && i<size) ? true : false;
}


char String::operator[](int i) const
{
	if (check(i))
		return charArr[i];
	else
		return ' ';
}


void String::write(int k, char ch)
{
	if (check(k))
		charArr[k] = ch;
	else
	{
		cout << "Index " << k << " exceeds array size! Nothing was done" << endl;
		return;
	}
}


int String::getSize()
{
	return size;
}


String& String::operator=(const String& str)
{
	/*if(str.charArr == 0)
	{
	delete[] charArr;
	charArr = 0;
	size = 0;
	return *this;
	}*/

	if (this != &str)
	{
		delete[] charArr;
		size = str.size;
		charArr = new char[str.size + 1];
		strcpy_s(charArr, str.size + 1, str.charArr);
	}

	return *this;
}


String& String::operator+(String& str)
{
	int temp = size + str.size + 1;
	char* ptr = new char[temp];
	strcpy_s(ptr, temp, charArr);
	strcat_s(ptr, temp, str.charArr);
	String* s = new String(ptr);
	delete[] ptr;
	return *s;
}


String& String::operator+=(String& str)
{
	if (str.charArr == 0)
		return *this;

	int temp = size + str.size + 1;

	size = size + str.size;

	char* ptr = new char[temp];
	strcpy_s(ptr, temp, charArr);
	strcat_s(ptr, temp, str.charArr);

	delete[] charArr;
	charArr = ptr;
	return *this;
}


bool String::operator==(String& str)
{
	if (strcmp(charArr, str.charArr) == 0)
		return true;
	else
		return false;
}


bool String::operator!=(String& str)
{
	if (strcmp(charArr, str.charArr) != 0)
		return true;
	else
		return false;
}


bool String::operator<(String& str)
{
	if (strcmp(charArr, str.charArr) < 0)
		return true;
	else
		return false;
}


bool String::operator>(String& str)
{
	if (strcmp(charArr, str.charArr) > 0)
		return true;
	else
		return false;
}


bool String::operator<=(String& str)
{
	if (strcmp(charArr, str.charArr) <= 0)
		return true;
	else
		return false;
}


bool String::operator>=(String& str)
{
	if (strcmp(charArr, str.charArr) >= 0)
		return true;
	else
		return false;
}


ostream& operator<<(ostream& os, String& str)
{
	os << str.charArr;
	return os;
}


istream& operator>>(istream& is, String& str)
{
	delete str.charArr;

	char* temp = new char[51];
	is >> temp;

	str.size = strlen(temp);
	//cout<<str.size<<endl;
	str.charArr = new char[str.size + 1];
	strcpy_s(str.charArr, str.size + 1, temp);

	delete temp;
	return is;
}