//oop_ex127.cpp
//a linked-list for int type

#include <iostream>

using namespace std;


//The entire chain of nodes can be encapsulated in an object
//of type List, as below, so as to hide the details of the
//implementation from a user of the linked list
class List
{
	//node in a linked list
	struct Node
	{
		Node* prev;
		Node* suc;
		int val;		//for int only!

		//constructor
		Node(Node* p, Node* s, const int& v)
			: prev(p), suc(s), val(v) { }
	};

	Node* head;

public:
	List() :head(0) {}

	List(const int& x) : head(new Node(0, 0, x)) {}

	void print_all()
	{
		for (Node* p = head; p; p = p->suc)
			cout << p->val << " ";
		cout << endl;
	}

	void add_to_list(List&, int);

	void remove_from_list(List&, int);
};

void List::add_to_list(List& li, int data)
{
	Node* new_Node = new Node(0, li.head, data);
	li.head = new_Node;
	new_Node->suc->prev = head;
}

void List::remove_from_list(List& li, int data)
{
	Node* p;

	for (p = li.head; p->val != data; p = p->suc)//find the node to be removed
	{
		if (p->suc == 0)
			return;
	}

	if (p == li.head)	//if item to be deleted is at the head
	{
		li.head = li.head->suc;
		li.head->prev = 0;
		delete p;
		return;
	}

	p->prev->suc = p->suc;
	if (p->suc != 0)	//if item to be deleted is not at the end
		p->suc->prev = p->prev;
	delete p;
}

void main()
{
	int i = 100;
	List* numlist = new List(i);
	numlist->print_all();

	cout << "adding 500 to the list" << endl;
	numlist->add_to_list(*numlist, 500);
	numlist->print_all();

	cout << "adding 600 to the list" << endl;
	numlist->add_to_list(*numlist, 600);
	numlist->print_all();


	cout << "removing 100 from the list" << endl;
	numlist->remove_from_list(*numlist, 100);
	numlist->print_all();

	cout << "removing 600 from the list" << endl;
	numlist->remove_from_list(*numlist, 600);
	numlist->print_all();

	cout << "removing 700 from the list" << endl;
	numlist->remove_from_list(*numlist, 700);
	numlist->print_all();

	system("pause");
}